<?php

namespace App\Models;

trait  DeviceTrailModel
{

    public static function onLine($box_no)
    {
        self::$db->update('devices')->where('box_no = ' . $box_no)->cols([
            'is_line' => 1
        ])->query();
    }

    public static function outLine($box_no)
    {
        self::$db->update('devices')->where('box_no = ' . $box_no)->cols([
            'is_line' => 0
        ])->query();
    }

    public static function updateData($box_no, $data = [], $other = [], $type, $time = 300)
    {
        $hash = "{$box_no}:{$type}:" . md5(implode(',', $data));
        if (self::$redis->get($hash)) {
            self::$redis->setex($hash, $time, 1);
            return false;
        } else {
            $keys = self::$redis->keys("{$box_no}:{$type}:*");
            if (count($keys)) {
                foreach ($keys as $key) {
                    self::$redis->del($key);
                }
            }

            self::$redis->setex($hash, $time, 1);
            $data = array_merge($data, $other);
            self::$db->update('devices')->where('box_no = ' . $box_no)->cols($data)->query();
            return true;
        }
    }

    public static function isDataChange($box_no, $data = [], $type, $time = 300)
    {
        $hash = "{$box_no}:{$type}:" . md5(implode(',', $data));
        if (self::$redis->get($hash)) {
            self::$redis->setex($hash, $time, 1);
            return false;
        }
        $keys = self::$redis->keys("{$box_no}:{$type}:*");
        if (count($keys)) {
            foreach ($keys as $key) {
                self::$redis->del($key);
            }
        }
        self::$redis->setex($hash, $time, 1);
        return true;
    }

}