<?php

namespace App\Servers;

use App\Common\CacheLogTrait;
use App\Common\DecodeTrait;
use App\Common\LogTrait;
use App\Models\DeviceTrailModel;

abstract class BaseServer
{
    use DecodeTrait, LogTrait, CacheLogTrait, DeviceTrailModel;

//    protected $db;
    protected static $db;
//    protected $redis;
    protected static $redis;
    protected $mongo;
    protected $client_id;
    protected $msg_id;

    public function __construct($param = [])
    {
        if (array_key_exists('db', $param)) {
//            $this->db = $param['db'];
            self::$db = $param['db'];
        }
        if (array_key_exists('redis', $param)) {
//            $this->redis = $param['redis'];
            self::$redis = $param['redis'];
        }
        if (array_key_exists('mongo', $param)) {
            $this->mongo = $param['mongo'];
        }
        if (array_key_exists('client_id', $param)) {
            $this->client_id = $param['client_id'];
        }
    }

    abstract public function main($body);
}