<?php

namespace App\Servers;

use App\Common\CacheLogTrait;
use App\Common\DecodeTrait;

class BoxResponseServer extends BaseServer
{
    public function main($body)
    {
        $body = $this->decodeBody($body);
        self::log($body, 'BoxResponseServer');
        if (!$body['status']) {
            //执行失败
            return false;
        }
        self::setCache($body['imei'] . ':' . ClientServer::RUN_CMD, 1);
        return false;
    }

    private function decodeBody($body)
    {
        $i = 0;
        $imei = self::decodeBoxNo(self::stitching($body, $i, 15, false));
        $i += 15;
        $status_dhex = self::stitching($body, $i, 1);

        $status = 0;
        if ($status_dhex == '55') {
            $status = 1;
        }

        if ($status_dhex == 'aa') {
            $status = 0;
        }

        return [
            'imei' => $imei,
            'status' => $status,
        ];
    }
}