<?php

namespace App\Servers;


class LocationServer extends BaseServer
{


    public function main($body)
    {
        self::log($body);
        $body = $this->decodeBody($body);
        //写位置信息
        self::log($body, '定位');
        self::setCache($body['imei'] . ':' . ClientServer::LOCATION_CMD, $body);

        self::updateData($_SESSION['box_no'], [
            'lat' => $body['lat'],
            'lng' => $body['lng'],
        ], ['last_update_time' => date("Y-m-d H::i::s")], 'location', 15 * 60);

        return false;
    }

    private function decodeBody($body)
    {
        $i = 0;
        $imei = self::decodeBoxNo(self::stitching($body, $i, 15, false));
        $i += 15;

        $lat = self::decodeLocation(self::stitching($body, $i, 4, false));
        $i += 4;

        $lng = self::decodeLocation(self::stitching($body, $i, 4, false));
        $i += 4;

        return [
            'imei' => $imei,
            'lat' => $lat,
            'lng' => $lng,
        ];
    }
}